;***********  Listing 2  ******  JOYTIME.ASM  ***********
;   Low-level joystick routines.
;   Copyright per Listing 1
;********************************************************

          small_code  equ      4
          large_code  equ      6

          model     equ      small_code ; set this for memory model

.MODEL SMALL
.CODE
          include timer.inc

          public    _gettimer
_gettimer proc      near
          mov       al,counter_0 + latch_cnt
          out       timer_cwd,al       ; latch counter 0
          jmp       $+2                ; fancy NOP
          in        al,timer_0         ; read counter LSB
          mov       ah,al              ;   and save in AH
          jmp       $+2                ; fancy NOP
          in        al,timer_0         ; read counter MSB
          xchg      ah,al              ; swap MSB & LSB
          ret
_gettimer endp



          public    _waitjoy
_waitjoy  proc      near
          push      bp
          mov       bp,sp

          push      bx
          push      dx

          mov       bx,[bp+model]      ; get mask parameter
          mov       dx,201h            ; set joystick port
          mov       al,bl
          out       dx,al              ; start joystick
          jmp       $+2                ; wait for inputs to settle
          mov       cx,game_timeout    ; timeout counter
agin:
          in        al,dx              ; read joystick
          test      al,bl              ; mask set?
          loopnz    agin               ; no, read again

          mov       ax,cx              ; yes, return value of timeout
          pop       dx
          pop       bx

          mov       sp,bp
          pop       bp
          ret
_waitjoy  endp


         public    _intson             ; Enable interrupts
_intson  proc      near
         sti                           ; STI = Set Interrupt Enable
         ret
_intson  endp


         public    _intsoff            ; Disable interrupts
_intsoff proc      near
         cli                           ; CLI = Clear Interrupt Enable
         ret
_intsoff endp

         end